﻿using System;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using NationalInstruments.DAQmx;
using System.Net;


namespace Save_Data_to_Database
{
    public partial class Form1 : Form
    {
         string connectionString = ConfigurationManager.ConnectionStrings["DatabaseConnectionString"].ConnectionString;

        public Form1()
        {
            InitializeComponent();

            timer1.Interval = 10000;

            timer1.Start();
        }


        private void timer1_Tick(object sender, EventArgs e)
        {

            GetSensorData();

            DateTime timeStamp = DateTime.Now;
            txtTimeStamp.Text = timeStamp.ToString();

            SaveMeasurementData();

        }

        private void txtDataRate_TextChanged(object sender, EventArgs e)
        {

            int dataRate;

            dataRate = Convert.ToInt32(txtDataRate.Text)*1000;

            timer1.Interval = dataRate;

        }


        void SaveMeasurementData()
        {
            string apiKey;
            double tagValue;

            string server = "https://api.thingspeak.com/";
            string webMethod;
            string uri;

            var webclient = new WebClient();

            apiKey = "XXXXXXXXXXXXXXXXX";

            tagValue = Convert.ToDouble(txtMeasurementValue.Text);

            webMethod = "update?api_key=" + apiKey + "&field1=" + tagValue;

            uri = server + webMethod;
            
            webclient.UploadString(uri, "POST", "");

        }

        void GetSensorData()
        {
            Task temperatureTask = new Task();

            AIChannel myAIChannel;

            myAIChannel = temperatureTask.AIChannels.CreateThermocoupleChannel(
                "Dev1/ai0",
                "Temperature",
                0,
                100,
                AIThermocoupleType.J,
                AITemperatureUnits.DegreesC
                );

            AnalogSingleChannelReader reader = new AnalogSingleChannelReader(temperatureTask.Stream);

            double analogDataIn = reader.ReadSingleSample();

            txtMeasurementValue.Text = analogDataIn.ToString("0.0");
        }

       
    }
}
